//PRIMEVS$ JOB (001),'INSTALL PRIMEVS',                                 00010000
//             CLASS=A,MSGCLASS=A,COND=(0,NE)                           00020000
//*-----------------------------------------------------------------*   00030000
//*        INSTALL THE 'PRIMEVS'  PROGRAM                               00040000
//*-----------------------------------------------------------------*   00050000
//PRIMEVS$ EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK'                    00060000
//ASM.SYSIN DD *                                                        00070000
         TITLE 'PRMEVSAM - PRIME VSAM - STEVE WENTWORTH'                00010000
*********************************************************************** 00020000
*                                                                     * 00030000
*                P R I M E   V S A M   C L U S T E R                  * 00040000
*                                                                     * 00050000
* THIS PROGRAM WRITES A KEYED RECORD TO A VSAM CLUSTER.               * 00060000
* THE KEY AND DATA ARE ALL X'00'.                                     * 00070000
*                                                                     * 00080000
* THIS PROGRAM THEN READS THIS RECORD AND THEN DELETES THE RECORD.    * 00090000
*                                                                     * 00100000
* COBOL PROGRAMS CAN NOW OPEN THIS VSAM CLUSTER FOR I/O.              * 00110000
* THERE IS NO LONGER A NEED FOR A SPECIAL 'INITIAL RECORD DELETE'     * 00120000
* STEP OR PROCESSING CODE TO SKIP THE FIRST RECORD OF THIS CLUSTER.   * 00130000
*                                                                     * 00140000
*********************************************************************** 00150000
*                                                                       00160000
*                                                                       00170000
*                                                                       00180000
*********************************************************************** 00190000
*                                                                     * 00200000
*                S A M P L E   E X E C U T I O N   J C L              * 00210000
*                                                                     * 00220000
*//         JOB                                                       * 00230000
*//* STEPNAME                TASK                                     * 00240000
*//* --------            -------------------------------------------- * 00250000
*//* IDC1                DEFINE BASE CLUSTER WITH INDEX AND DATA.     * 00260000
*//*                     DISPLAY CATALOG INFORMATION.                 * 00270000
*//*                     NOTE HI-USED RBA.                            * 00280000
*//* PRMEVSAM            WRITE RECORD WITH X'00' KEY AND DATA.        * 00290000
*//*                     DELETE THIS RECORD.                          * 00300000
*//* IDC2                DISPLAY CATALOG INFORMATION.                 * 00310000
*//*                     NOTE HI-USED RBA.                            * 00320000
*//*                                                                  * 00330000
*//IDC1   EXEC  PGM=IDCAMS                                            * 00340000
*//SYSPRINT DD SYSOUT=*                                               * 00350000
*//SYSIN    DD *                                                      * 00360000
* DELETE (VSAM.SAMPLE.C)                                              * 00370000
* DEFINE CLUSTER(NAME(VSAM.SAMPLE.C)           +                      * 00380000
*          VOLUME(VSAM00)                      +                      * 00390000
*          RECORDSIZE(80,80)                   +                      * 00400000
*          RECORDS(100,50)                     +                      * 00410000
*          INDEXED                             +                      * 00420000
*          KEYS(5,0)                           +                      * 00430000
*          SHAREOPTIONS(1,3)       )           +                      * 00440000
*        INDEX(NAME(VSAM.SAMPLE.I)             +                      * 00450000
*          CISZ(2048)              )           +                      * 00460000
*        DATA(NAME(VSAM.SAMPLE.D)              +                      * 00470000
*          CISZ(4096)              )                                  * 00480000
* LISTC LEVEL(VSAM.SAMPLE)                     +                      * 00490000
*       ALL                                                           * 00500000
*//PRMEVSAM EXEC PGM=PRMEVSAM                                         * 00510000
*//DS      DD DSN=VSAM.SAMPLE.C,DISP=SHR                              * 00520000
*//SYSUDUMP DD SYSOUT=*                                               * 00530000
*//IDC2   EXEC  PGM=IDCAMS                                            * 00540000
*//SYSPRINT DD SYSOUT=*                                               * 00550000
*//SYSIN    DD *                                                      * 00560000
* LISTC LEVEL(VSAM.SAMPLE)                     +                      * 00570000
*       ALL                                                           * 00580000
*                                                                     * 00590000
*********************************************************************** 00600000
*                                                                       00610000
*                                                                       00620000
*                                                                       00630000
*********************************************************************** 00640000
*                                                                     * 00650000
*                R E G I S T E R   U S A G E                          * 00660000
*                                                                     * 00670000
* R0:   ABEND MACRO                                                   * 00680000
* R1:   SYSTEM SERVICES MACROS AND IO MACROS                          * 00690000
* R4:   ADDRESS OF LOGICAL RECORD AREA                                * 00700000
* R5:   LENGTH OF LOGICAL RECORD                                      * 00710000
* R6:   SECOND OPERAND ADDRESS (X'00000000') FOR MVCL                 * 00720000
* R7:   PADDING BYTE AND LENGTH (X'00000000') FOR MVCL                * 00730000
* R12:  PROGRAM BASE ADDRESS REGISTER                                 * 00740000
* R13:  ADDRESS OF REGISTER SAVE AREA                                 * 00750000
* R14:  RETURN ADDRESS                                                * 00760000
* R15:  ENTRY POINT ADDRESS/RETURN CODE                               * 00770000
*                                                                     * 00780000
*********************************************************************** 00790000
*                                                                       00800000
*                                                                       00810000
*                                                                       00820000
*********************************************************************** 00830000
*                                                                     * 00840000
*              L O A D   M O D U L E   A T T R I B U T E S            * 00850000
*                                                                     * 00860000
* NOT REENTERABLE                                                     * 00870000
* ADDRESSING MODE = 24                                                * 00880000
* RESIDENCY MODE  = 24                                                * 00890000
*                                                                     * 00900000
*********************************************************************** 00910000
*                                                                       00920000
*                                                                       00930000
*                                                                       00940000
*********************************************************************** 00950000
*                                                                     * 00960000
*                C H A N G E   H I S T O R Y                          * 00970000
*                                                                     * 00980000
* 31-JUL-91/0900     VERSION 1 RELEASE 0                              * 00990000
*                                                                     * 01000000
*********************************************************************** 01010000
         EJECT                                                          01020000
         MACRO                                                          01030000
         CPYRIGHT &VER=1,&REL=0                                         01040000
         USING &SYSECT,15                                               01050000
         B     CPYR&SYSNDX        BRANCH OVER IDENTIFIER AND COPYRIGHT  01060000
         DROP  15                                                       01070000
         DC    CL8'&SYSECT'       CSECT NAME                            01080000
         DC    C'VERSION &VER'    VERSION LEVEL                         01090000
         DC    C'RELEASE &REL'    RELEASE LEVEL                         01100000
         DC    C'&SYSDATE'        ASSEMBLY DATE                         01110000
         DC    C'&SYSTIME'        ASSEMBLY TIME                         01120000
         DC    C'STEVE WENTWORTH' AUTHOR NAME                           01130000
         DC    C'COPYRIGHT 1991'  COPYRIGHT NOTICE                      01140000
CPYR&SYSNDX CNOP 0,4                                                    01150000
         MEND                                                           01160000
         MACRO                                                          01170000
         REGEQU                                                         01180000
         LCLA  &RN                                                      01190000
&RN      SETA  0                                                        01200000
.GENEQU  ANOP                                                           01210000
R&RN     EQU   &RN                                                      01220000
&RN      SETA  &RN+1                                                    01230000
         AIF   (&RN NE 16).GENEQU                                       01240000
         MEND                                                           01250000
         MACRO                                                          01260000
         BEGPGM                                                         01270000
         STM   14,12,12(13)       SAVE CALLER'S REGISTER CONTENTS       01280000
         LR    12,15              PLACE BASE ADDRESS INTO REGISTER 12   01290000
         USING &SYSECT,12         ESTABLISH ADDRESSABILITY              01300000
         LA    2,RSVE&SYSNDX      R2 ==> THIS CSECT'S REG SAVE AREA     01310000
         ST    2,8(,13)           CALLER'S SAVE ==> THIS SAVE AREA      01320000
         ST    13,4(,2)           THIS SAVE ==> CALLER'S SAVE AREA      01330000
         LR    13,2               R13 ==> THIS CSECT'S REG SAVE AREA    01340000
         B     RSVE&SYSNDX+(4*18) BRANCH OVER REGISTER SAVE AREA        01350000
RSVE&SYSNDX DC  18F'0'            REGISTER SAVE AREA                    01360000
         MEND                                                           01370000
         MACRO                                                          01380000
         ENDPGM                                                         01390000
         L     13,4(,13)          R13 ==> CALLER'S REGISTER SAVE AREA   01400000
         LM    14,12,12(13)       RESTORE CALLER'S REGISTER CONTENTS    01410000
         XR    15,15              SET RETURN CODE TO ZERO               01420000
         BR    14                 RETURN TO CALLER                      01430000
         MEND                                                           01440000
         MACRO                                                          01450000
&L       PATCH  &NBYTES=64,&PRINT=NOGEN                                 01460000
         PUSH  PRINT                                                    01470000
         PRINT &PRINT                                                   01480000
&L       DS    0F                                                       01490000
         DC    &NBYTES.S(*)                                             01500000
         POP   PRINT                                                    01510000
         MEND                                                           01520000
         EJECT                                                          01530000
PRMEVSAM CSECT                                                          01540000
         REGEQU                   R0 EQU 0, ETC.                        01550000
         CPYRIGHT                 IDENTIFIER AND COPYRIGHT              01560000
         EJECT                                                          01570000
         BEGPGM                   BEGIN PROGRAM EXECUTION               01580000
*                                                                       01590000
* CREATE AND WRITE THE NULL RECORD                                      01600000
*                                                                       01610000
         OPEN  (DS)               CONNECT VSAM CLUSTER TO PROGRAM       01620000
         LTR   R15,R15            OK OPEN?                              01630000
         BNZ   OPENERR            NO                                    01640000
         SHOWCB ACB=DS,           OBTAIN LRECL                         X01650000
               AREA=RECLEN,                                            X01660000
               LENGTH=4,                                               X01670000
               FIELDS=(LRECL)                                           01680000
         LTR   R15,R15            OK SHOWCB?                            01690000
         BNZ   SHOWERR            NO                                    01700000
GETSTOR  GETMAIN EU,              ACQUIRE STORAGE FOR LOGICAL RECORD   X01710000
               LV=RECLEN,                                              X01720000
               A=@AREA,                                                X01730000
               RELATED=(FREESTOR,'GET STORAGE')                         01740000
         LTR   R15,R15            OK GETMAIN?                           01750000
         BNZ   GETMNERR           NO                                    01760000
         L     R4,@AREA           R4 ==> LOGICAL RECORD AREA            01770000
         L     R5,RECLEN          R5 CONTAINS LOGICAL RECORD LENGTH     01780000
         MODCB RPL=RPL,           MODIFY THE RPL CONTROL BLOCK         X01790000
               AREA=(4),                                               X01800000
               AREALEN=(5),                                            X01810000
               RECLEN=(5)                                               01820000
         LTR   R15,R15            OK MODCB?                             01830000
         BNZ   MODERR             NO                                    01840000
         XR    R6,R6              SET SECOND OPERAND ADDRESS FOR MVCL   01850000
         XR    R7,R7              SET PAD AND LENGTH TO X'00' FOR MVCL  01860000
         MVCL  R4,R6              PLACE ALL X'00' INTO LOGICAL RECORD   01870000
         PUT   RPL=RPL            WRITE A LOGICAL RECORD                01880000
         LTR   R15,R15            OK PUT?                               01890000
         BNZ   PUTERR             NO                                    01900000
         CLOSE (DS)               DISCONNECT VSAM CLUSTER FROM PROGRAM  01910000
         LTR   R15,R15            OK CLOSE?                             01920000
         BNZ   CLOSEERR           NO                                    01930000
*                                                                       01940000
* READ AND DELETE THE NULL RECORD                                       01950000
*                                                                       01960000
         MODCB ACB=DS,            MODIFY THE ACCESS CONTROL BLOCK      X01970000
               MACRF=(KEY,SEQ,OUT)                                      01980000
         LTR   R15,R15            OK MODCB?                             01990000
         BNZ   MODERR             NO                                    02000000
         MODCB RPL=RPL,           MODIFY THE REQUEST PARAMETER LIST    X02010000
               OPTCD=(KEY,SEQ,UPD)                                      02020000
         LTR   R15,R15            OK MODCB?                             02030000
         BNZ   MODERR             NO                                    02040000
         OPEN  (DS)               CONNECT VSAM CLUSTER TO PROGRAM       02050000
         LTR   R15,R15            OK OPEN?                              02060000
         BNZ   OPENERR            NO                                    02070000
         GET   RPL=RPL            READ LOGICAL RECORD                   02080000
         LTR   R15,R15            OK GET?                               02090000
         BNZ   GETERR             NO                                    02100000
         ERASE RPL=RPL            DELETE LOGICAL RECORD                 02110000
         LTR   R15,R15            OK ERASE?                             02120000
         BNZ   ERASEERR           NO                                    02130000
         CLOSE (DS)               DISCONNECT VSAM CLUSTER FROM PROGRAM  02140000
         LTR   R15,R15            OK CLOSE?                             02150000
         BNZ   CLOSEERR           NO                                    02160000
FREESTOR FREEMAIN EU,             RELEASE STORAGE                      X02170000
               LV=RECLEN,                                              X02180000
               A=@AREA,                                                X02190000
               RELATED=(GETSTOR,'FREE STORAGE')                         02200000
         LTR   R15,R15            OK FREEMAIN?                          02210000
         BNZ   FREEMNER           NO                                    02220000
         ENDPGM                   END PROGRAM EXECUTION                 02230000
         PATCH PRINT=GEN          PATCH AREA                            02240000
         EJECT                                                          02250000
DS       ACB   AM=VSAM,           ACCESS CONTROL BLOCK                 X02260000
               DDNAME=DS,                                              X02270000
               MACRF=(DIR,OUT)                                          02280000
RPL      RPL   AM=VSAM,           REQUEST PARAMETER LIST               X02290000
               ACB=DS                                                   02300000
@AREA    DC    F'0'               ADDRESS OF LOGICAL RECORD AREA        02310000
RECLEN   DC    F'0'               LENGTH OF LOGICAL RECORD              02320000
         EJECT                                                          02330000
OPENERR  ABEND 101,DUMP           ERROR PROCESSING                      02340000
SHOWERR  ABEND 102,DUMP                                                 02350000
MODERR   ABEND 103,DUMP                                                 02360000
PUTERR   ABEND 104,DUMP                                                 02370000
GETERR   ABEND 105,DUMP                                                 02380000
ERASEERR ABEND 106,DUMP                                                 02390000
CLOSEERR ABEND 107,DUMP                                                 02400000
GETMNERR ABEND 108,DUMP                                                 02410000
FREEMNER ABEND 109,DUMP                                                 02420000
         END                                                            02430000
//LKED.SYSLMOD DD DSN=SYS2.LINKLIB,DISP=SHR                             00090000
//SYSIN DD *                                                            00100000
 NAME PRIMEVS(R)                                                        00110000
//                                                                      00120000
